// TODO: get rid of the twig-js mixed parts as much as possible or better find an other/newer way to inject backend vars in js.


    function popUpContent(feature) {

        var out = [];

        for (key in feature.properties) {
            if (key === 'type_geom') {
                var type_geom = feature.properties[key];
                
            }
            else {
                if (key === 'name') {
                    
                    out.push('<h1>' + feature.properties['name'] + ' <small>[' + feature.properties['id'].substring(1) + ']</small></h1>');
                    if (feature.properties['object_type'] !== null && feature.properties['object_type'] !== undefined) { 
                        out.push(feature.properties['object_type'] + '<br />'); 
                    }
                    
                    if (feature.properties['type'] == 'objet' || feature.properties['type'] == 'action' || feature.properties['type'] == 'photo' ) {
                        /* popup on action geojson open the object page */
                        var redir = feature.properties['type'] ;
                        if (feature.properties['type']=='action'){
                            var redir = 'objet' ;
                        } 
                        // quick fix pour le prb de carte vide sur les fiches de synthese depuis les ajout ici du offline

                        let myId = 'default' ;
                        if (feature.properties['id'].indexOf('_') != -1) {
                            myId = feature.properties['id'].substring(1,feature.properties['id'].indexOf('_')) ;
                        } else {
                            myId = feature.properties['id'].substring(1) ;
                        } 
                        

                        if (feature.properties['layer_id']) {                          

                            // quick fix: here we do the offline tricks only if layer_id is defined. TODO: better
                            out.push('<div class="btn btn-primary" id="openSheetBtn' + myId + '" href="#" onclick="disableLoadOnPan();openClose(\'rightColumn\',\'{{ mapWidth|default(60) }}%\',\'map\',\'{{ (100-mapWidth|default(60)) }}%\');sendData(\'id=' + myId + '\',\'/' + redir + '\',\'objet\',event, true);$(\'#infos\').hide(150);$(\'#objet\').show(150);history.pushState(null, null, \'{{ url('map') }}/'+redir+'/' + myId + '\');' + '$(\'#fiche-objet-id\').attr(\'value\',' + myId + '); document.getElementById(\'fiche-objet-id\').click();' + '$(\'#fiche-objet-type-id\').attr(\'value\',' + feature.properties['layer_id'].substring(17) + '); document.getElementById(\'fiche-objet-type-id\').click();' + '">Fiche</div>');
                        } else {
                            out.push('<div class="btn btn-primary" href="#" onclick="disableLoadOnPan();openClose(\'rightColumn\',\'{{ mapWidth|default(60) }}%\',\'map\',\'{{ (100-mapWidth|default(60)) }}%\');sendData(\'id=' + myId + '\',\'/' + redir + '\',\'objet\',event, true);$(\'#infos\').hide(150);$(\'#objet\').show(150);history.pushState(null, null, \'{{ url('map') }}/'+redir+'/' + myId + '\');">Fiche</div>');
                        }
                    } else {

                        myId = feature.properties['id'] ;
                        if ( (feature.properties['popupButtonOnClickTarget'] !== undefined) && (feature.properties['popupButtonOnClickTarget'] !== null)) {
                            out.push('<div class="btn btn-primary" id=openSheetBtn' + myId + ' href="#" onclick="openClose(\'rightColumn\',\'{{ mapWidth|default(60) }}%\',\'map\',\'{{ (100-mapWidth|default(60)) }}%\');sendData(     \'urlToEmbed=' + feature.properties['popupButtonOnClickTarget'] + '\', \'generic-other-layer\', \'objet\' ,event, true);$(\'#infos\').hide(150);$(\'#objet\').show(150);history.pushState(null, null, \'{{ url('map') }}\');">Fiche</div>');
                        }
                    }
                }
                if (key === 'description') {
                            out.push('<p>' + feature.properties[key] + '</p>');
                }
            }
        } 

        return out ;       
    }

    

    

    function createFeature(form, sysma_object_id, sysma_object_type_id, event) {
        
        event.preventDefault();

        $('.o'+sysma_object_type_id+'GeoCancelButton').css('display', 'none'); 
        $('.o'+sysma_object_type_id+'GeoNewButton').css('display', 'inline-block');


        s = $('#' + form).serialize(); // recupere toutes les données du formulaire
        $.ajax({
            type : "POST",
            url : '{{ url('object-create-commit') }}',
            data : s,
            async : false,
            success: function (data,event) {
                var json = $.parseJSON(data);
                    if (json.status === 'error') {
                        sendData('message=' + json.message + '&data=' + json.data, '/error', divSuccess, null);
                    } else {
                        refreshLayer('objecttype', sysma_object_type_id, null, null, { 'center' : map.getCenter(), 'zoom' : map.getZoom() } );
                        drawnItems.clearLayers();                
                        sendData('id='+sysma_object_id, '{{ url('object') }}', 'objet', null);
                    }
            }
        })

        return false;
    
    }
    
    
    function saveFeature(object_id, type_geom) {      
      
        selectedFeature = map._layers[object_id];    
        //console.log('selectedFeature')  
        //console.log(selectedFeature)  
        selectedFeature.disableEdit() ;
        var shape_for_db = JSON.stringify(selectedFeature.toGeoJSON());
        var data = JSON.parse(shape_for_db);
        map.editTools.stopDrawing()

        openClose('rightColumn', '{{ mapWidth|default(60) }}%', 'map', '{{ (100-mapWidth|default(60)) }}%');            
       
        
        $('#infos').hide(150);
        $('#objet').show(150);   
       
                
        $.ajax({
            type: "POST",
            url: '{{ url('object-update-geom') }}',
            data: 'geom=' + data.geometry.coordinates + '&id_layer=' + object_id + '&geometry_type=' + type_geom,
            async: false,
            success: function (data, event)
            {             
                
                refreshLayer('objecttype', selectedFeature.options.sysmaOptions.object_id, null, null, { 'center' : map.getCenter(), 'zoom' : map.getZoom() });
                drawnItems.clearLayers();                
                sendData('id='+object_id.substring(1), '{{ url('object') }}', 'objet', null);

            }
        });

        
    }


